static class ch1ent
{
	byte value;
public:
	inline byte read() const { return value; }
	inline void write(const byte data) { value = data; }
} CH1_ENT;
static class ch1wave
{
	byte value;
	byte pattern[32];
public:
	inline byte read() const { return value; }
	inline void write(const byte data)
	{
		static const byte len[4] = {4,8,16,24};
		unsigned a;
		value = data;
		for(a=0; a<32; a++)
			pattern[a] = a < len[data>>6] ? 0 : 255;
	}
	byte operator[] (const unsigned index) { return pattern[index]; }
} CH1_WAVE;
static void setch1freq();
static class ch1freqlo
{
public:
	byte value;
	inline void write(const byte data)
	{
		value = data;
		setch1freq();
	}
} CH1_FREQ_LO;
static class ch1freqhikick
{
public:
	byte value;
	inline byte read() const { return value&0x40; }
	inline void write(const byte data)
	{
		value = data;
		setch1freq();
	}
} CH1_FREQ_HI_KICK;
static word CH1_FREQ=0;
static void setch1freq()
{
	CH1_FREQ = 133333 / (2048 - (((CH1_FREQ_HI_KICK.value&7)<<8) | CH1_FREQ_LO.value));
}
static void ch1envupd();
static class ch1env
{
	byte value;
	bool up;
	byte volume;
	timer tim;
public:
	ch1env() : tim(0, ch1envupd) { }
	inline byte read() const { return value; }
	inline void write(const byte data)
	{
		value = data;
		up = data&8;
		volume = data>>4;
		tim.changerate(64 * (data&7));
	}
	inline void update()
	{
		if(!(CH1_FREQ_HI_KICK.value & 64))
		{
			if(up) { if(volume < 15) ++volume; }
			else if(volume > 0) --volume;
		}
	}
} CH1_ENV;
static void ch1envupd()
{
	CH1_ENV.update();
}





static class ch2ent
{
	byte value;
public:
	inline byte read() const { return value; }
	inline void write(const byte data) { value = data; }
} CH2_ENT;
static class ch2wave
{
	byte value;
	byte pattern[32];
public:
	inline byte read() const { return value; }
	inline void write(const byte data)
	{
		static const byte len[4] = {4,8,16,24};
		unsigned a;
		value = data;
		for(a=0; a<32; a++)
			pattern[a] = a < len[data>>6] ? 0 : 255;
	}
	byte operator[] (const unsigned index) { return pattern[index]; }
} CH2_WAVE;
static void setch2freq();
static class ch2freqlo
{
public:
	byte value;
	inline void write(const byte data)
	{
		value = data;
		setch2freq();
	}
} CH2_FREQ_LO;
static class ch2freqhikick
{
public:
	byte value;
	inline byte read() const { return value&0x40; }
	inline void write(const byte data)
	{
		value = data;
		setch2freq();
	}
} CH2_FREQ_HI_KICK;
static word CH2_FREQ=0;
static void setch2freq()
{
	CH2_FREQ = 133333 / (2048 - (((CH2_FREQ_HI_KICK.value&7)<<8) | CH2_FREQ_LO.value));
}
static void ch2envupd();
static class ch2env
{
	byte value;
	bool up;
	byte volume;
	timer tim;
public:
	ch2env() : tim(0, ch2envupd) { }
	inline byte read() const { return value; }
	inline void write(const byte data)
	{
		value = data;
		up = data&8;
		volume = data>>4;
		tim.changerate(64 * (data&7));
	}
	inline void update()
	{
		if(!(CH2_FREQ_HI_KICK.value & 64))
		{
			if(up) { if(volume < 15) ++volume; }
			else if(volume > 0) --volume;
		}
	}
} CH2_ENV;
static void ch2envupd()
{
	CH2_ENV.update();
}




static class ch3switch
{
public:
	bool enabled;
	ch3switch() : enabled(true) { }
	inline byte read() const { return enabled?128:0; }
	inline void write(const byte data) { enabled = data & 128; }
	
} CH3_ONOFF;
static class ch3volume
{
public:
	byte shift;
	ch3volume() : shift(0) { }
	inline byte read() const { return ((shift+1)&3) << 5; }
	inline void write(const byte data)
	{
		shift = ((data>>5)+3)&3;
	}
} CH3_VOLUME;
